version: '3.8'

services:
  web:
    image: registry.gitlab.syscops.dev/benjamin.komjathy/diplomamunka-backend:${TAG}
    restart: unless-stopped
    environment:
      - DATABASE_URL=postgresql://todo_backend:${PG_PW}@db:5432/todo_backend
    depends_on:
      - db
    labels:
      - traefik.enable=true
      - traefik.http.routers.todo_backend.rule=Host(`todo.${TAG}.benidiploma.hu`) && PathPrefix(`/api`)
      - traefik.http.routers.todo_backend.tls=true
      - traefik.http.routers.todo_backend.tls.certresolver=dnsResolver
      - traefik.http.routers.todo_backend.entrypoints=websecure
      - traefik.http.routers.todo_backend.tls.options=default
      - traefik.http.routers.todo_backend.middlewares=https-redirect@file,security-headers@file,strip-api-prefix@file
      - traefik.http.routers.todo_backend-insecure.rule=Host(`todo.${TAG}.benidiploma.hu`) && PathPrefix(`/api`)
      - traefik.http.routers.todo_backend-insecure.middlewares=https-redirect@file,security-headers@file,strip-api-prefix@file
      - traefik.http.routers.todo_backend-insecure.entrypoints=web
      - traefik.http.services.todo_backend.loadbalancer.server.port=80
      - traefik.http.routers.todo_backend.service=todo_backend
      - traefik.http.routers.todo_backend-insecure.service=todo_backend
      - traefik.docker.network=traefiknet
    networks:
      - traefiknet
      - databasenet
 

  db:
    image: postgres:13-alpine
    restart: unless-stopped
    volumes:
      - ./postgres_data:/var/lib/postgresql/data/
    environment:
      - POSTGRES_USER=todo_backend
      - POSTGRES_PASSWORD=${PG_PW}
      - POSTGRES_DB=todo_backend
    networks:
      - databasenet



networks:
  databasenet:
  traefiknet:
    external:
      name: traefiknet
